((

	PAGEVARS.FTH

	J Lee :- 23/1/91

	MicroProcessor Engineering Ltd
	133/133a Hill Lane
	Southampton
	SO1 5AF

	tele:	(0703) 631441
	inter:	+44 703 631441


        Creates PAGE-VAR definitions. Can be loaded by any module.

))




only forth also c-c definitions
decimal




\ {Page-Management }Page-Management .. J Lee -- 22/06/90
\


decimal
0 constant {Page-Management	\ define maximum size of chunk data
255 constant }Page-Management




\ Page-Addr Page-Addr@ Page-Lab .. J Lee -- 22/06/90
\


decimal

Variable Page-Addr                \ use only by building
                                  \ words
{Page-Management Page-Addr !


: Page-Addr@	( -- n )
	Page-Addr @  ;


: Page-lab	( -- )
	Page-addr@ constant  ;



\ Page-var ?Page-Addr.. J Lee -- 22/06/90
\


decimal

: ?Page-Addr	( -- )
	Page-addr@ }Page-Management 10 - u>   \ Enough space?
	abort" Out of Page Management space"  ;     \  error if not


: Page-Var                                \ -- [Parent]
	?Page-addr                            \ -- addr [Chd]
	Page-addr@ constant
	cell(s) Page-addr +!  ;




\ Allot(page) .. J Lee -- 22/06/90
\

: Allot(page)	( n -- )
	Page-Addr +!
	?Page-addr  ;




\ Start mapping Page management space .. J Lee -- 24/06/90
\


decimal

8 dcell(s)* constant Vsize(s)	\ size of Context(s)

16 constant #Threads(s)			\ number of symbol table threads / voc
16 constant #Threads(t)			\ number of target threads / voc


Page-lab Chunk-Link			\ link list for chunks
		dcell(s) allot(page)		\   is a double link list

Page-var Latest-Chunk			\ pointer to latest chunk created in page

Page-lab Chunk-Threads			\ Symbol threads for this chunks
		#threads(s) cell(s)* allot(page)		\ allocate space for threads

Page-lab Current(s)			\ Current for symbols
		dcell(s) allot(page)		\ voc pointers are 32-bit

Page-lab Context(s)			\ Context for symbols
		Vsize(s) allot(page)		\  reserve Context space

Page-lab <Voc-Link(s)			\ Backward Voc-Link for symbols
		dcell(s) allot(page)

Page-lab >Voc-Link(s)			\ forward Voc-Link for symbols
		dcell(s) allot(page)

Page-lab Curr->Voc-Link(s)		\ last voc symbol in chain
		dcell(s) allot(page)

Page-var Dp(s)				\ Symbol space DP
Page-var O-I					\ origin in image
Page-var Dp(t)				\ Target dict. pointer
Page-var Voc-Seg(p)			\ For PAGES
Page-var Page-Voc-Seg                   \ for WITH-CODE
Page-var Blk.Cur(p)			\
Page-var Flg.Upd(p)			\
Page-var Last(s)				\ last symbol created
Page-var Last(t)				\ nfa of last target word
Page-lab 'Latest(s)			\ last symbol in target
		dcell(s) allot(page)
Page-lab 'Latest:				\ Latest ':' symbol
		dcell(s) allot(page)
Page-lab Page-Voc(s)			\ voc. address for ONLY in pages > 0
		dcell(s) allot(page)

