\ code to control the PWM output of the 80c196

((
This code released as example code only, for use with
80c196 cross-compiler
(c) MicroProcessor Engineering Ltd., 1991
133 Hill Lane
Southampton
SO1 5AF

Phone: (+44) 703 631441
Fax:   (+44) 703 339691

))

\ -----End of Page-----
\ -- R.G.G -- 3/12/91 --  constants and variables

hex

\ -- addr ; sfr register addresses

014 constant WSR
016 constant IOC1
00B constant IOC2
017 constant PWM-control

\ -----End of Page-----
\ -- R.G.G -- 3/12/91 --  code

decimal

: set-pwm		\ period -- ; set up period of pwm o/p
  PWM-control c!		\ set up the register
;

: init-pwm		\ -- ; initialises for pwm by setting IOC1 bit 0 to 1
  04 ioc2 set-bit		\ set prescaler to .5
  15 WSR c!			\ 
  IOC1 dup c@			\  
  1 or				\ enable bit 
  0 WSR c!			\ set off
  swap c!			\ 
  128 set-pwm			\ and give initial duty cycle
;

