\ Target text file words for use with XSHELL v2

((
Copyright (c) 1991

MicroProcessor Engineering
133 Hill Lane
Southampton SO1 5AF
England

tel: (+44) 703 631441
fax: (+44) 703 339691

First Release: 29/04/91

Changes:	See RELEASE.DOC for full details
))

\ end-load                                         sfp 26/01/90

decimal

: end-load      \ -- ; switch back to keyboard input
  xon/xoff off                  \ turn off handshaking
  echoing on                    \ turn echoing back on
  assign (error) to-do error    \ normal error handler again
;
\ This word is automatically performed at the end of a download
\ It re-assigns the error handlers, and tidies up the comms

internal

\ file-error                                       sfp 26/01/90

decimal

: file-error    \ n -- ;
  ^e ser-emit                           \ trigger host error
  CR ." Error # " .  SPACE here $. CR   \ show error
  ack ser-emit                          \ finish host error
  Wait-Ack/Nack Disk-error !            \ get status respons
  xon ser-emit                          \ initiate end-load
  end-load                              \ clean up
  xoff ser-emit                         \ finish comms protocol
  abort                                 \ abort into system
;


\ curr-text-file                                R. sfp 26/01/90

decimal

variable curr-text-file  64 allot-ram
\ the name of the current text file as a counted string

\ This is required in order to maintain a default file-name on
\ the target system. A default is required in order to have a
\ file-name to send to the host when it expects one, even if
\ the user does not type one in.

\ use                                              sfp 26/01/90

: set-usefile   \ $addr --
  curr-text-file over c@ 1+ cmove  ;    \ move string

external

: use           \ <file> -- ;
  bl word                       \ get string from keyboard
  dup ^a send$                  \ send it
  set-usefile  ;                \ make it current file
\ This word sets up the name of the file to use by default
\ The default extension '.FTH' is added if necessary.
\ The filename is set up on both the host and the target.
\ $from-file                                    R. sfp 26/01/90

: $from-file    \ first last $addr -- ;
  ^f send$                      \ send file name
  send-block#                   \ send last-p#
  send-block#                   \ send first-p#
  synch-to-host                 \ syncronise
  echoing off                   \ not echoing
  xon/xoff on                   \ initiate handshaking
  assign file-error to-do error \ new error handler
  ;
\ Primitive to FROM-FILE


\ alone all onwards upto                        R. sfp 26/01/90

: alone         \ n -- first last ;
  dup  ;                        \ to load only one page

: all           \ -- first last ;
  1 -1  ;                       \ to load all pages

: onwards       \ first -- first last ;
  -1  ;                         \ to load pages after 'first'

: upto          \ last -- first last ;
  1 swap  ;                     \ to load pages before 'last'


\ from from-file                                   sfp 26/01/90

: from          \ first last -- ;
  curr-text-file $from-file  ;          \ compile from file

: from-file     \ first last <file> -- ;
  bl word                               \ get file name
  dup count upper                       \ convert to upper case
  $from-file  ;                         \ compile from file

((
  Use: 1)      USE TEST   ) as a pair
               ALL FROM   )
       or
       2)      ALL FROM-FILE TEST
))
\ all done

decimal

;p
